angular.module('beamng.apps')
.directive('asciispd', ['logger', 'bngApi', 'StreamsManager', function (logger, bngApi, StreamsManager) {
  return {
    template: '<div class="asciispd" id="asciispd" style="height: 100%;padding: 0px;">' + 
	'<pre style="background: black; color:white; padding: 4px;margin:0px;" id="aff"><span class="uncornTopLeft">█</span><span class="untop">█████</span><span class="uncornTopRight">█</span> <span class="deuxcornTopLeft">█</span><span class="deuxtop">█████</span><span class="deuxcornTopRight">█</span> <span class="troiscornTopLeft">█</span><span class="troistop">█████</span><span class="troiscornTopRight">█</span><br><span class="unleftTop">█</span>     <span class="unrightTop">█</span> <span class="deuxleftTop">█</span>     <span class="deuxrightTop">█</span> <span class="troisleftTop">█</span>     <span class="troisrightTop">█</span><br><span class="unleftTop">█</span>     <span class="unrightTop">█</span> <span class="deuxleftTop">█</span>     <span class="deuxrightTop">█</span> <span class="troisleftTop">█</span>     <span class="troisrightTop">█</span><br><span class="unMidLeft">█</span><span class="unMid">█████</span><span class="unMidRight">█</span> <span class="deuxMidLeft">█</span><span class="deuxMid">█████</span><span class="deuxMidRight">█</span> <span class="troisMidLeft">█</span><span class="troisMid">█████</span><span class="troisMidRight">█</span> <br><span class="unleftBot">█</span>     <span class="unrightBot">█</span> <span class="deuxleftBot">█</span>     <span class="deuxrightBot">█</span> <span class="troisleftBot">█</span>     <span class="troisrightBot">█</span><br><span class="unleftBot">█</span>     <span class="unrightBot">█</span> <span class="deuxleftBot">█</span>     <span class="deuxrightBot">█</span> <span class="troisleftBot">█</span>     <span class="troisrightBot">█</span><br><span class="uncornBotLeft">█</span><span class="unbot">█████</span><span class="uncornBotRight">█</span> <span class="deuxcornBotLeft">█</span><span class="deuxbot">█████</span><span class="deuxcornBotRight">█</span> <span class="troiscornBotLeft">█</span><span class="troisbot">█████</span><span class="troiscornBotRight">█</span><br></pre>'+
	'</div>',
	replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      var requiredStrems = ['engineInfo', 'electrics'];
	//logger.debug('<asciispd>1 Link! ');
      StreamsManager.add(requiredStrems);
	  
	  element.on('load', function () {	/*logger.debug('<asciispd>22222 load! ');*/});
        var svg = element[0].children[0];
      /*var settingsInterval;
		
		//actu_asciispd();
		settingsInterval = setInterval(function () {
			try {
			actu_asciispd();
			}
			catch(err) {
				svg.innerHTML = err.message;
			}
			//clearInterval(settingsInterval);
		}, 5000);*/
		
        // polling if svg is loaded
        /*settingsInterval = setInterval(function () {
          if (svg && svg.settingsChanged) {
            
            clearInterval(settingsInterval);
          }
        }, 200);*/

        scope.$on('VechicleChange', function () { 
          //svg.vechicleChanged(); 
        });
        
        scope.$on('VehicleFocusChanged', function (event, data) {
          /*if(data.mode == 1 && svg && svg.vehicleChanged) {
             svg.vehicleChanged();
          }*/
        });
		var unitSystem = 'km';
		// * 3.6 = m/s to km/h
		// * 2.23694 = m/s to mph
		var speedUnitMultiplier = 3.6;
		var speedUnitText ="kmh";

        scope.$on('SettingsChanged', function (event, data) {
			//logger.debug('<asciispd> received SettingsChanged event');
			unitSystem = data.values.uiUnitDistance;
			if(unitSystem == 'km') {
			speedUnitText = 'kmh';
			speedUnitMultiplier = 3.6;
		  } else if(unitSystem == 'mi') {
			speedUnitText = 'mph';
			speedUnitMultiplier = 2.23694;
		  } else {
			speedUnitText = 'm/s';
			speedUnitMultiplier = 1;
		  }
          /*if (svg && svg.settingsChanged) {
            //
            svg.settingsChanged(data);
          }*/
        });
		bngApi.engineLua('settings.requestState()');

        bngApi.engineLua('settings.requestState()');

var patate	= {

cssrules: function (){
  var rules={}; var ds=document.styleSheets,dsl=ds.length;
  for (var i=0;i<dsl;++i){
    var dsi=ds[i].cssRules,dsil=dsi.length;
    for (var j=0;j<dsil;++j) rules[dsi[j].selectorText]=dsi[j];
  }
  return rules;
},

css_getclass:function (name){

  if (!patate.rules.hasOwnProperty(name)) throw 'todo:deal_with_notfound_case';
  return patate.rules[name];
},

//seg_on:function (cls){patate.css_getclass("."+cls).style.color = 'white';},
//seg_of:function (cls){patate.css_getclass("."+cls).style.color = 'grey';},

seg_on:function (cls){var x = document.getElementsByClassName(cls); for( var i=0; i<x.length ;i++){x[i].style.color = 'white';}},
seg_of:function (cls){var x = document.getElementsByClassName(cls); for( var i=0; i<x.length ;i++){x[i].style.color = 'grey';}},

asciispd_print7seg:function (div,A,B,C,D,E,F,G)
{
	if(A){patate.seg_on(div+"top");}else{patate.seg_of(div+"top");}
	if(B){patate.seg_on(div+"rightTop");}else{patate.seg_of(div+"rightTop");}
	if(C){patate.seg_on(div+"rightBot");}else{patate.seg_of(div+"rightBot");}
	if(D){patate.seg_on(div+"bot");}else{patate.seg_of(div+"bot");}
	if(E){patate.seg_on(div+"leftBot");}else{patate.seg_of(div+"leftBot");}
	if(F){patate.seg_on(div+"leftTop");}else{patate.seg_of(div+"leftTop");}
	if(G){patate.seg_on(div+"Mid");}else{patate.seg_of(div+"Mid");}
	
	if(A || F){patate.seg_on(div+"cornTopLeft");}else{patate.seg_of(div+"cornTopLeft");}
	if(A || B){patate.seg_on(div+"cornTopRight");}else{patate.seg_of(div+"cornTopRight");}
	if(D || E){patate.seg_on(div+"cornBotLeft");}else{patate.seg_of(div+"cornBotLeft");}
	if(D || C){patate.seg_on(div+"cornBotRight");}else{patate.seg_of(div+"cornBotRight");}
	
	if(B || C || G){patate.seg_on(div+"MidRight");}else{patate.seg_of(div+"MidRight");}
	if(E || F || G){patate.seg_on(div+"MidLeft");}else{patate.seg_of(div+"MidLeft");}	
},


asciispd_printlcd:function (cha,div)
{
	switch(cha)
	{
		case '0':
		case 0:
			patate.asciispd_print7seg(div,1,1,1,1,1,1,0); break;
		case '1':
		case 1:
			patate.asciispd_print7seg(div,0,1,1,0,0,0,0); break;
		case '2':
		case 2:
			patate.asciispd_print7seg(div,1,1,0,1,1,0,1); break;
		case '3':
		case 3:
			patate.asciispd_print7seg(div,1,1,1,1,0,0,1); break;
		case '4':
		case 4:
			patate.asciispd_print7seg(div,0,1,1,0,0,1,1); break;
		case '5':
		case 5:
			patate.asciispd_print7seg(div,1,0,1,1,0,1,1); break;
		case '6':
		case 6:
			patate.asciispd_print7seg(div,1,0,1,1,1,1,1); break;
		case '7':
		case 7:
			patate.asciispd_print7seg(div,1,1,1,0,0,0,0); break;
		case '8':
		case 8:
			patate.asciispd_print7seg(div,1,1,1,1,1,1,1); break;
		case '9':
		case 9:
			patate.asciispd_print7seg(div,1,1,1,1,0,1,1); break;		
	}	
},

asciispd_printlcdnb:function(nb)
{
	var un = parseInt(nb / 100);
	var deux = parseInt(nb % 100 / 10);
	var trois = parseInt(nb % 100 % 10);
	
	patate.asciispd_printlcd(un,"un")
	patate.asciispd_printlcd(deux,"deux")
	patate.asciispd_printlcd(trois,"trois")	
}
};
		patate.rules  = patate.cssrules();

		var testVar = 0; // for the test mode
		var displayMode = 2;
		var offline = false;
		var Hold =0, Wold=0;
        scope.$on('streamsUpdate', function (event, streams) {
          //svg.update(streams);
		  //actu_asciispd();
		  
		  if(element[0].clientHeight != Hold || element[0].clientWidth !=Wold)
		  {
			  //constant
			   var fw = 8;		//default font width
			   var fh = 13+2;	//default font height
			   var cw = 40;		//Number of char in a line
			   var lh = 7;		//number of line
			   
			   var H = element[0].clientHeight - 0;
			   var W = element[0].clientWidth - 0;
			   var fsize = 13;
			   
			   /*if( W/(cw*fw)  *  (fh*lh) > H )
			   {
				   //use height*/
				   fsize = (H / lh) -2;
			   /*}
			   else
			   {
				   //use width
				   var h = W * ( (lh*fh)/(fw*cw) )
				   fsize = (h / lh) -2
			   }*/
			   svg.style.fontSize = Math.floor(fsize)+"px";
			   svg.style.lineHeight = (Math.floor(fsize)+2)+"px";
			   Hold = element[0].clientHeight;
			   Wold = element[0].clientWidth;
			   

		  }
		  
		  
		  var isStreamValid = streams.engineInfo && streams.engineInfo[0] !== undefined && streams.electrics;

		  var data = {};
		  if(isStreamValid)
		  {
				var rpm_max = Math.round(streams.engineInfo[1] / 1000) * 1000 + 1000; // we round up to the nearest 1000
				//var rpm = getRandomInt(0, 8000)
				
				 if (displayMode == 2) {
					// real data mode, no animation
					if(streams.electrics.wheelspeed) {
					  data.speedtext = Math.round(streams.electrics.wheelspeed * speedUnitMultiplier);
					} else if (streams.electrics.airspeed) {
					  data.speedtext = Math.round(streams.electrics.airspeed * speedUnitMultiplier);
					}
					(function () {
					  if(streams.engineInfo[13] == "manual") {
						var gear = streams.engineInfo[5];
						var gearStr = gear.toString();
						
						if(gear == 0) gearStr = 'N';
						else if(gear == -1) gearStr = 'R';
						else if(-gear > 1) gearStr = 'R' + (-gear);

						data.geartext = gearStr;
					  } else {
						data.geartext = ["P","R","N","D","2","1"][Math.round(streams.electrics.gear_A*5)];
					  }
					})();

					data.fuel = streams.engineInfo[11] / streams.engineInfo[12];
					data.parkingBrake = streams.electrics.parkingbrake;
					data.absWorking = streams.electrics.abs;
					data.signalL = streams.electrics.signal_L;
					data.signalR = streams.electrics.signal_R;
					data.waterTemp = streams.electrics.watertemp;
					data.lowBeam = streams.electrics.lowbeam;
					data.highBeam = streams.electrics.highbeam;
					data.rpm = (streams.electrics.rpm || 0.0);
					data.tc = streams.electrics.tcs;
					data.esp = streams.electrics.esp;

				  } else if (displayMode == 0) {
					// starting animation
					testVar = testVar + 0.04;
					if(testVar > 1) testVar = 1;
					data.speedtext = Math.round(testVar * 100) ;
					data.geartext = Math.round(testVar * 5);
					data.fuel = testVar;
					var boolTest = true;  //Math.round(testVar * 10) % 10;
					data.parkingBrake = boolTest;
					data.absWorking = boolTest;
					data.signalL = boolTest;
					data.signalR = boolTest;
					data.oilTemp = testVar;
					data.lowBeam = boolTest;
					data.highBeam = !boolTest;
					data.rpm = testVar;
					if(testVar >= 1) { 
					  testVar = 0; 
					  displayMode = 1;
					}

				  } else if (displayMode == 1) {
					// starting animation -> real data transition

					if(streams.electrics.wheelspeed) {
					  data.speedtext = Math.round(streams.electrics.wheelspeed * speedUnitMultiplier);
					} else {
					  data.speedtext = '';
					  speedUnitText.textContent = '';
					}

					(function () {
					  var gear = streams.engineInfo[5];
					  var gearStr = gear.toString();
					  if(gear == 0) {
						gearStr = 'N';
					  }
					  else if(gear == -1) {
						gearStr = 'R';
					  }
					  data.geartext = gearStr;
					})();

					data.parkingBrake = streams.electrics.parkingbrake;
					data.absWorking = streams.electrics.abs;
					data.signalL = streams.electrics.signal_L;
					data.signalR = streams.electrics.signal_R;
					data.lowBeam = streams.electrics.lowbeam;
					data.highBeam = streams.electrics.highbeam;
					if(streams.electrics.tcs == undefined)
						data.tc = 0;
					else
						data.tc = streams.electrics.tcs;
					if(streams.electrics.esp == undefined)
						data.esp = 0;
					else
						data.esp = streams.electrics.esp;
					
					var oilok = Math.abs(data.oilTemp - streams.electrics.oiltemp) &lt; 0.005;
					if(!oilok) data.oilTemp += (streams.electrics.oiltemp - data.oilTemp) * 0.2;

					var rpmperc = streams.electrics.rpm / rpm_max;
					var rpmok = Math.abs(data.rpm - rpmperc) &lt; 0.005;
					if(!rpmok) data.rpm += (rpmperc - data.rpm) * 0.2;

					var fuelperc = streams.engineInfo[11] / streams.engineInfo[12];
					var fuelok = Math.abs(data.fuel - fuelperc) &lt; 0.005;
					if(!fuelok) data.fuel += (fuelperc - data.fuel) * 0.2;

					if(oilok && rpmok && fuelok) {
					  displayMode = 2;
					}
				  }
				
				//Display *********************************************
				//console.time("display");
			  patate.asciispd_printlcdnb(parseInt(data.speedtext));
			  //console.timeEnd("display");
		  }
		  else
		  {
			  //printfc("Engine not found", "red");

			  offline =true;
		  }
        });



      scope.$on('$destroy', function () {
        StreamsManager.remove(requiredStrems);
      });
    }
  };
}]);