angular.module('beamng.apps')
.directive('asciitacho', ['logger', 'bngApi', 'StreamsManager', function (logger, bngApi, StreamsManager) {
  return {
    template: '<div class="asciiTacho" id="asciiTacho" style="height: 100%;padding: 0px;">' + '<pre id="tty" style="background: black;padding:1px;margin:0px;color:white;font-weight: bold;"></pre></div>',
	replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      var requiredStrems = ['engineInfo', 'electrics','escData'];
	//logger.debug('<asciitacho>1 Link! ');
      StreamsManager.add(requiredStrems);
	  
	  element.on('load', function () {	/*logger.debug('<asciitacho>22222 load! '); */  });
	  
	  var svg = element[0].children[0];
	  var l1 = element[0].children[0].children['l1'];
	  svg.innerHTML = "INIT ....\n\n\n\n DES PATATES";
        
      /*var settingsInterval;
		
		//actu_asciitacho();
		settingsInterval = setInterval(function () {
			try {
			actu_asciitacho();
			}
			catch(err) {
				svg.innerHTML = err.message;
			}
			//clearInterval(settingsInterval);
		}, 5000);*/
	var tmpout = "";
var stdout = document.getElementById("tty");
var l1="████|████|████|████|████|████|████|████|"
var l2="    1    2    3    4    5    6    7    8"
var gauge="██████████████████"
stdout.innerhtml+="\n\npatate\n\n";

function printfc(txt,col)
{ 
  svg.innerHTML += "<spam style='color: "+col+"'>"+txt+"</spam>";
}
function println(){svg.innerHTML += "\n";}

function Draw_RPM(cur,red)
{
	if(cur>8000)
		cur=8000;
	if(red>8000)
		red=8000;
  var limc = cur/8000 * l1.length *1.01;
  var limr = red/8000 * l1.length *1.01;
  if(limc >= limr)
  {
	  limc = limr;
  }
  
  /*printfc( l1.slice(0,limc), "white");
  printfc( l1.slice(limc,l1.length), "grey");*/
	/*if(limc < limr)//pas zone rouge
	{*/
		printfc( l1.slice(0,limc), "white");
		printfc( l1.slice(limc,limr), "grey");
		printfc( l1.slice(limr,l1.length), "#660000");
	/*}
	else
	{
		printfc( l1.slice(0,limr), "white");
		printfc( l1.slice(limr,limc), "red");
		printfc( l1.slice(limc,l1.length), "#660000");
	}*/

  println();
  
  printfc( l2, "white");
  println();
}

function Draw_FT(fuel,temp)
{
  var fs = fuel * gauge.length *1.05;
  var tempNormalized = Math.max(Math.min((temp - 50) / 80, 1), 0)
  var ts = tempNormalized * gauge.length *1.05;
  printfc( "F", "white");
  printfc( gauge.slice(0,fs), "blue");
  printfc( gauge.slice(fs,gauge.length), "grey");
  
  printfc( " T", "white");
  printfc( gauge.slice(0,ts), "red");
  printfc( gauge.slice(ts,gauge.length), "grey");
  printfc( " ", "white");
  println();
}

		
        // polling if svg is loaded
        /*settingsInterval = setInterval(function () {
          if (svg && svg.settingsChanged) {
            
            clearInterval(settingsInterval);
          }
        }, 200);*/

        scope.$on('VechicleChange', function () { 
          //svg.vechicleChanged(); 
        });
        
        scope.$on('VehicleFocusChanged', function (event, data) {
          /*if(data.mode == 1 && svg && svg.vehicleChanged) {
             svg.vehicleChanged();
          }*/
        });
		var unitSystem = 'km';
		// * 3.6 = m/s to km/h
		// * 2.23694 = m/s to mph
		var speedUnitMultiplier = 3.6;
		var speedUnitText ="kmh";

        scope.$on('SettingsChanged', function (event, data) {
			//logger.debug('<asciitacho> received SettingsChanged event');
			unitSystem = data.values.uiUnitDistance;
			if(unitSystem == 'km') {
			speedUnitText = 'kmh';
			speedUnitMultiplier = 3.6;
		  } else if(unitSystem == 'mi') {
			speedUnitText = 'mph';
			speedUnitMultiplier = 2.23694;
		  } else {
			speedUnitText = 'm/s';
			speedUnitMultiplier = 1;
		  }
          /*if (svg && svg.settingsChanged) {
            //
            svg.settingsChanged(data);
          }*/
        });
		bngApi.engineLua('settings.requestState()');

        bngApi.engineLua('settings.requestState()');

		


		var testVar = 0; // for the test mode
		var displayMode = 2;
		var offline = false;
		var Hold =0, Wold=0;
        scope.$on('streamsUpdate', function (event, streams) {
          //svg.update(streams);
		  //actu_asciitacho();
		  
		  if(element[0].clientHeight != Hold || element[0].clientWidth !=Wold)
		  {
			  //constant
			   var fw = 8;		//default font width
			   var fh = 13+2;	//default font height
			   var cw = 40;		//Number of char in a line
			   var lh = 4;		//number of line
			   
			   var H = element[0].clientHeight - 0;
			   var W = element[0].clientWidth - 0;
			   var fsize = 13;
			   
			   /*if( W/(cw*fw)  *  (fh*lh) > H )
			   {
				   //use height*/
				   fsize = (H / lh) -2;
			   /*}
			   else
			   {
				   //use width
				   var h = W * ( (lh*fh)/(fw*cw) )
				   fsize = (h / lh) -2
			   }*/
			   svg.style.fontSize = Math.floor(fsize)+"px";
			   svg.style.lineHeight = (Math.floor(fsize)+2)+"px";
			   Hold = element[0].clientHeight;
			   Wold = element[0].clientWidth;
			   
				/*if(l1.offsetWidth > W)
				{
					//alert("Largeur ="+W+"\nLargeur actuel="+l1.offsetWidth)
					fsize = Math.floor(fsize);
					while(l1.offsetWidth > W && fsize > 10)
					 {
						 fsize--;
						 svg.style.fontSize = Math.floor(fsize)+"px";
						svg.style.lineHeight = (Math.floor(fsize)+2)+"px";
					 }
				}*/

		  }
		  
		  
		  var isStreamValid = streams.engineInfo && streams.engineInfo[0] !== undefined && streams.electrics;

		  var data = {};
		  if(isStreamValid)
		  {
				var rpm_max = Math.round(streams.engineInfo[1] / 1000) * 1000 + 1000; // we round up to the nearest 1000
				
				 if (displayMode == 2) {
					// real data mode, no animation
					if(streams.electrics.wheelspeed) {
					  data.speedtext = Math.round(streams.electrics.wheelspeed * speedUnitMultiplier);
					} else if (streams.electrics.airspeed) {
					  data.speedtext = Math.round(streams.electrics.airspeed * speedUnitMultiplier);
					}
					(function () {
					  if(streams.engineInfo[13] == "manual") {
						var gear = streams.engineInfo[5];
						var gearStr = gear.toString();
						
						if(gear == 0) gearStr = 'N';
						else if(gear == -1) gearStr = 'R';
						else if(-gear > 1) gearStr = 'R' + (-gear);

						data.geartext = gearStr;
					  } else {
						data.geartext = ["P","R","N","D","2","1"][Math.round(streams.electrics.gear_A*5)];
					  }
					})();

					data.fuel = streams.engineInfo[11] / streams.engineInfo[12];
					data.parkingBrake = streams.electrics.parkingbrake;
					data.absWorking = streams.electrics.abs;
					data.signalL = streams.electrics.signal_L;
					data.signalR = streams.electrics.signal_R;
					data.waterTemp = streams.electrics.watertemp;
					data.lowBeam = streams.electrics.lowbeam;
					data.highBeam = streams.electrics.highbeam;
					data.rpm = (streams.electrics.rpm || 0.0);
					data.tc = streams.electrics.tcs;
					data.esp = streams.electrics.esc;

				  } else if (displayMode == 0) {
					// starting animation
					testVar = testVar + 0.04;
					if(testVar > 1) testVar = 1;
					data.speedtext = Math.round(testVar * 100) ;
					data.geartext = Math.round(testVar * 5);
					data.fuel = testVar;
					var boolTest = true;  //Math.round(testVar * 10) % 10;
					data.parkingBrake = boolTest;
					data.absWorking = boolTest;
					data.signalL = boolTest;
					data.signalR = boolTest;
					data.oilTemp = testVar;
					data.lowBeam = boolTest;
					data.highBeam = !boolTest;
					data.rpm = testVar;
					if(testVar >= 1) { 
					  testVar = 0; 
					  displayMode = 1;
					}

				  } else if (displayMode == 1) {
					// starting animation -> real data transition

					if(streams.electrics.wheelspeed) {
					  data.speedtext = Math.round(streams.electrics.wheelspeed * speedUnitMultiplier);
					} else {
					  data.speedtext = '';
					  speedUnitText.textContent = '';
					}

					(function () {
					  var gear = streams.engineInfo[5];
					  var gearStr = gear.toString();
					  if(gear == 0) {
						gearStr = 'N';
					  }
					  else if(gear == -1) {
						gearStr = 'R';
					  }
					  data.geartext = gearStr;
					})();

					data.parkingBrake = streams.electrics.parkingbrake;
					data.absWorking = streams.electrics.abs;
					data.signalL = streams.electrics.signal_L;
					data.signalR = streams.electrics.signal_R;
					data.lowBeam = streams.electrics.lowbeam;
					data.highBeam = streams.electrics.highbeam;
					if(streams.electrics.tcs == undefined)
						data.tc = 0;
					else
						data.tc = streams.electrics.tcs;
					if(streams.escData == undefined)
						data.esp = 0;
					else
						data.esp = streams.escData;
					
					var oilok = Math.abs(data.oilTemp - streams.electrics.oiltemp) < 0.005;
					if(!oilok) data.oilTemp += (streams.electrics.oiltemp - data.oilTemp) * 0.2;

					var rpmperc = streams.electrics.rpm / rpm_max;
					var rpmok = Math.abs(data.rpm - rpmperc) < 0.005;
					if(!rpmok) data.rpm += (rpmperc - data.rpm) * 0.2;

					var fuelperc = streams.engineInfo[11] / streams.engineInfo[12];
					var fuelok = Math.abs(data.fuel - fuelperc) < 0.005;
					if(!fuelok) data.fuel += (fuelperc - data.fuel) * 0.2;

					if(oilok && rpmok && fuelok) {
					  displayMode = 2;
					}
				  }
				
				//Display *********************************************
			  stdout.innerHTML="";
			  svg.innerHTML += "<span id='l1'>";
			  Draw_RPM( Math.round(data.rpm) , streams.engineInfo[1]);
			  svg.innerHTML += "</span>";
			  
			  Draw_FT(data.fuel,data.waterTemp)
			  
			  printfc(("00" + data.speedtext).slice(-3)+""+speedUnitText, "white");
			  
			  if(data.geartext.length = 1)
				printfc(" "+data.geartext+" ", "white");
			else
				printfc(" "+data.geartext+"", "white");
			  
			  printfc("<", data.signalL==0? "grey": "green");
			  printfc(">  ", data.signalR==0? "grey": "green");
			  printfc("(P) ", data.parkingBrake==0? "grey": "red");
			  
			  if( data.lowBeam==0 && data.highBeam == 0)
			  {
				printfc("/D   ", "grey");
			  }
			  else
			  {
				  if(data.lowBeam == 1)
					  printfc("/D   ", "green");
				  else
					  printfc("=D   ", "Blue");
				  
			  }
			  
			  printfc("ABS ", data.absWorking==0? "grey": "orange");
			  
			  if(data.esp == 0 || data.esp == undefined)
				  printfc("ESP ", "grey");
			  else
			  {
				  if(data.esp == 1)
					  printfc("ESP ", "orange");
				  else
					printfc("ESP ", Math.abs(data.esp.yawRate - data.esp.desiredYawRate)>0.1 ? "orange": "grey"); //never tested lol
			  }
			  printfc("TC ", (data.tc==0 || data.tc == undefined)? "grey": "orange");
			  printfc(("000" + Math.round(data.rpm)).slice(-4)+"RPM", "white");
		  }
		  else
		  {
			  stdout.innerHTML="";
			  printfc("Engine not found", "red");
			  println();
			  
			  
			  offline =true;
		  }
        });



      scope.$on('$destroy', function () {
        StreamsManager.remove(requiredStrems);
        //clearInterval(settingsInterval);
      });
    }
  };
}]);